var DJIParser = require("../index");
var fs = require("fs");

var parser = new DJIParser();

var rows = [];

parser.on("OSD", function(obj) {
  rows.push([
    obj.getFlyTime(),
    obj.getLatitude(),
    obj.getLongitude(),
    obj.getHeight(),
    obj.getPitch(),
    obj.getYaw(),
    obj.getXSpeed(),
    obj.getYSpeed(),
    obj.getZSpeed(),
    obj.getRoll(),
    obj.getCompassError(),
    obj.getWaveError(),
    obj.getGpsLevel(),
    obj.isVibrating()
  ]);
});

parser.parse(fs.readFileSync("DJIFlightRecord_2015-12-29_[19-05-48].txt"));

fs.writeFileSync("output.csv", rows.map(function(row) { return row.join(","); }).join("\n"));